<?php
/*
 * Ajax Chat for TRPG ver.1.3
 * (c)2007 Cake All rights reserved.
 * Mail : cake_67@users.sourceforge.jp
 * Home : http://trpgtools-onweb.sourceforge.jp/
 *
 * [注意事項他]
 * 本チャットスクリプトの使用および配布は、BSDライセンスに基づきます。
 * BSDライセンスの詳細につきましては、添付のライセンス.txtを参照してください。
 *
 * BSDライセンス概要＆使用上の注意
 * 1. このスクリプトはフリーソフトです。以下の条件を満たす限りにおいて、使用・改造・再配布（オリジナルおよび改造版の両方とも）は自由です。
 * 再配布する場合、上記著作権表示、本条件書きおよび第2項・第3項の責任限定規定を必ず含めてください。
 * 2. 同梱のアイコンの大部分は、Petite Prier様(http://snow.if.tv/)の素材です。
      本スクリプトの使用および再配布時にアイコンをそのまま用いる場合は、配布元の規定も遵守してください。
 * 3. 本スクリプトは無保証です。自己責任で使用してください。このスクリプトを使用したいかなる損害に対しても、作者は一切の責任を負いません。
 * 4. 設置および使用方法に関する質問は、配布サイトの掲示板にお願いします。ただし、必ず回答できるとは限りません。
 * メールによる質問は、ご遠慮ください。
 */

/*****************
 *  設定ファイル：共通
 *****************/

/*
 * 設定変更方法
 * define('xxxx', 'oooo'); ← 'oooo'の中を書き換えてください。
 * $xxxx = 'oooo';  ← 'oooo'の中を書き換えてください。
 */

// 基本設定
    // チャット名
define('TITLE', 'Ajaxchat for TRPG');

    // 現在画面に表示する行数
define('MAX_NUM', 40);

    // ホームページのURL(返り先）
define('HOME', 'http://trpgtools-onweb.sourceforge.jp/index.php');

    // 管理者用パスワード
define('MASTERPASS', 'password');

    // 管理者用パスワードの暗号化キー
define('ADMIN_HASH_KEY', 'ajaxchat');

// タグの使用設定
    // タグを使用可能にする // (0:しない、1:する)
    // 下記で指定のタグと、フォントタグ(sizeとcolor)のみ可能です
$allow_tag = 1;
    // 許可するタグ(同じタグで閉じられる、パラメータ指定のないタグのみ可能です)
$tags = array(
            array('tag' => 'b', 'name' => '太字', 'show_icon' => true),
            array('tag' => 'i', 'name' => '斜体', 'show_icon' => true),
            array('tag' => 'u', 'name' => '下線', 'show_icon' => true),
            array('tag' => 's', 'name' => '打ち消し線', 'show_icon' => true),
        );
if ($tags[0]) {
    $taglist = "";
    foreach($tags as $v) {
        $taglist .= $v['tag']."(".$v['name']."), ";
    }
}

    // タグアイコンを表示する
    //(image/ディレクトリ以下に、word_font_[タグ名].gif のアイコン画像設置が必須です)
    // $tagの設定で、show_iconの値がtrueのタグのみ表示します
$show_tag_icon = 1; //(0:しない、1:する)
    // 本文中のURLを自動リンクする
$autolink = 1; // (0:しない、1:する）


//ダイス関連
    // 一度に振れる最大ダイス数(0でダイス不使用。最大数は100までです)
define('DICE_MAX', 10);
    // ダイスボタンで触れる汎用ダイスの設定
$preset_dice = array(
    '2D6',
    '1D6',
    '3D6',
    '1D8',
    '1D10',
    '1D20',
    '1D100',
);
    // ダイスメッセージ色
define('DICE_COLOR', '7793BF');


// 入室前表示（改行のみタグ不要です。他、HTMLタグは有効です）
    // 任意メッセージ（空欄可)
$help = '';

     // タグ関連
if ($allow_tag) {
    $help = '「HTMLタグ」関連ヘルプ';
    $help .= '許可するタグは、'.$taglist.'フォントタグ(色とサイズのみ)です。';
}
if ($autolink) {
    $help .= '発言中のURLはオートリンクされます。';
}
    // ダイス関連
if((int)DICE_MAX != 10) {
    $help .= '「ダイス」ヘルプ
発言欄で[2d6+2*2-3]のように入力してください。';
}
    // 他
$help .= '「ささやき」ヘルプ
「参加者」表示の行で、「ささやき」したい相手の名前をクリックしてください。
ふきだしアイコンをクリックすると「ささやき」が終了します。
パスワードを入力していないと、「ささやき」は使えません。

動作確認：IE6.0、FireFox2.0、LunaScape4.1、Opera9.0、Netscape 7.1
';


// 保管用過去ログ(HTML化した過去ログ)を公開する
$public_pastlog = 1; // 0:非公開、1:公開

    // クッキー保管期間
$cookie_expire_time = 30; // (日) 0:クッキーに保管しない
    // クッキー名
$cookie_name = 'AjaxChat';

    // 書きこみ禁止IP
$block_ip = array(
'66.180.82.','18.241.20.','66.35.255.','128.241.20.', //トレンドマイクロ社ロボットのIPです。ウィルスバスターユーザ二重発言の防止用なので、削除しないでください。
'192.168.1.1', // 禁止IPはこちらに追加
);


//表示メッセージなどの設定
    // ステータス欄デフォルト入力
$status = '';
    // ステータス表示色
$status_color = '777777';
    // PC欄最大数
$pc_num = 5;
    // システム表示名
$system = 'System';
    // システム文字色
define('COLOR_SYSTEM', '7793BF');
    // 入室時に表示されるメッセージ
$online_msg = 'さんが入室しました。';
    // 退室時に表示されるメッセージ
$offline_msg = 'さんが退室しました。';
    // 名前入力欄への表示
$noname = 'お名前';
    // 文字色カラーコード設定
$color_code = array("00","55","99","BB","FF");


// アイコン設定
    // ダイスアイコン
$dice_icon = './image/d6.gif';
    // ホームアイコン
$home_icon = './image/home_b.gif';
    // ヘルプアイコン
$help_icon = './image/help_b.gif';
    // リフレッシュアイコン
$reload_icon = './image/reload_b.gif';
    // 管理画面アイコン
$admin_icon = './image/property_b.gif';
    // フォントタグ挿入アイコン
$word_font_f = './image/file_font_T_b.gif';
    // ささやき関連
        // ささやきマーク
$whisper = './image/comment_r_b.gif';
        // ささやき中
$whisper_off = './image/key_open.gif';
        // ささやき解除
$whisper_on = './image/key_normal.gif';
    // PC関連
        // PC欄追加
$pc_show = './image/item_move_left.gif';
        // PC欄削除
$pc_hide = './image/item_move_right.gif';
        // PC色・ステータス欄表示
$pc_status_icon = './image/file_pen_b.gif';
        // PC色変更アイコン
$pc_font_icon = './image/font_f_b.gif';
    // 過去ログ関連
        // 過去ログディレクトリ開アイコン
define ('pastlog_dir_open_icon', './image/fol_op_b.gif');
        // 過去ログディレクトリ開アイコン
define ('pastlog_dir_close_icon',  './image/fol_cl_b.gif');
        // 過去ログディレクトリ追加アイコン
$pastlog_dir_add_icon = './image/fol_new_b.gif';
        // 過去ログディレクトリ削除アイコン
$pastlog_dir_del_icon = './image/fol_del_b.gif';

    // クッキー関連
        // クッキー登録アイコン
$cookie_write_icon ='./image/bookmark_bl_b.gif';
        // クッキー削除アイコン
$cookie_delete_icon ='./image/bookmark_del_b.gif';


// データ取得間隔
    // オンライン中
$getdata_on = 2;  //(秒)
        // ROM中
$getdata_off = 90; //(秒)

// ファイル名
    // 最新ログファイル名
$recent_log = './trpgchat.log';
    // 過去ログ保管ディレクトリ
$past_dir = './past/';
    // 管理用過去ログ保管ディレクトリ
$master_past_dir = './master_past/';
    // 直近過去ログファイル名
$past_log = './trpgchat_past.log';
    // メンバーチェッカーログファイル名
$now_member = './member.log';
    // ロックファイル
$lockfile = 'lock.txt';
$lockfile2 = 'lock2.txt';




/*
 * 詳細設定:通常は変更しないでください
 */
mb_language('Japanese');
mb_http_input('auto');
mb_http_output('utf8');
ini_set('mbstring.encoding_translation','On');
ini_set('mbstring.output_buffering','On');
ini_set('mbstring.output_hanler','mb_output_handler');
ini_set('session.use_cookies', '1');
ini_set('session.use_only_cookies', '1');
//ini_set('session.savepath', '/tmp');

define('METHOD', 'GET');


/*
 * 著作権とバージョン表示(改変しないでください)
 */
define('COPYRIGHT', '<a href="http://trpgtools-onweb.sourceforge.jp/" target="_blank">Ajax Chat for TRPG</a> ver.1.3 Copyright(c) Cake 2007 All Rights Reserved.<br> * icons:<a href="http://snow.if.tv/" target="_blank">Petite Prier</a> Thanks!');

?>